SystemOrganization addCategory: #'SBE-Morphic'!

Morph subclass: #CrossComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Morphic'!

!CrossComposite methodsFor: 'as yet unclassified' stamp: 'chc 10/29/2013 16:11'!
addCrossDecoration: aDecoration
	self subclassResponsibility
	! !

CrossComposite subclass: #CrossDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Morphic'!

Morph subclass: #CrossMorph
	instanceVariableNames: 'horizontalBar verticalBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Morphic'!

!CrossMorph methodsFor: 'as yet unclassified' stamp: 'chc 10/25/2013 16:28'!
containsPoint: aPoint
	| crossHeight crossWidth | 
	crossHeight := ( self height / 3.0) rounded.
	crossWidth := (self width / 3.0) rounded.
	horizontalBar := self bounds insetBy: 0 @ crossHeight. 
	verticalBar := self bounds insetBy: 	crossWidth @ 0.
	^ (horizontalBar containsPoint: aPoint)
			or: [verticalBar containsPoint: aPoint]! !

!CrossMorph methodsFor: 'as yet unclassified' stamp: 'chc 11/2/2013 13:48'!
drawOn: aCanvas
	| crossHeight crossWidth horizontalBar verticalBar | 
	crossHeight := self height / 3.0.
	crossWidth := self width / 3.0.
	horizontalBar := self bounds insetBy: 0 @ crossHeight. 
	verticalBar := self bounds insetBy: crossWidth @ 0. 
	aCanvas fillRectangle: horizontalBar color: Color red.
	aCanvas fillRectangle: verticalBar color: self color! !

Morph subclass: #MorphCrossExperiment
	instanceVariableNames: 'next flagthing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Morphic'!

MorphCrossExperiment subclass: #MorphComposite
	instanceVariableNames: 'children decoration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Morphic'!

MorphComposite subclass: #CrossMorphHorizontalBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Morphic'!

!CrossMorphHorizontalBar methodsFor: 'as yet unclassified' stamp: 'chc 11/5/2013 16:34'!
addDecoration: newDecoration
	|dec|
	dec := self decoration.
	newDecoration next: dec. 
	self decoration: newDecoration! !

!CrossMorphHorizontalBar methodsFor: 'as yet unclassified' stamp: 'chc 11/5/2013 16:32'!
decoration 	
	
	decoration ifNil: [
	decoration := self decoration: (MorphStateHolder new contents: self)  ].
	^decoration! !

!CrossMorphHorizontalBar methodsFor: 'as yet unclassified' stamp: 'chc 11/5/2013 16:31'!
decoration: anObject
	decoration := anObject! !

!CrossMorphHorizontalBar methodsFor: 'as yet unclassified' stamp: 'chc 11/20/2013 16:10'!
drawOn: aCanvas	
	| crossHeight horizontalBar |
	flagthing = true ifTrue: [ Transcript show: decoration "aCanvas draw: self decoration" ].
	crossHeight := self height / 3.0.
	horizontalBar := self bounds insetBy: 0 @ crossHeight. 
	aCanvas fillRectangle: horizontalBar color: self color.

	! !

!CrossMorphHorizontalBar methodsFor: 'as yet unclassified' stamp: 'chc 11/20/2013 16:10'!
initialize
	super initialize. 
	flagthing := true! !

!MorphComposite methodsFor: 'as yet unclassified' stamp: 'chc 11/20/2013 16:09'!
flagthing
	^flag! !

!MorphComposite methodsFor: 'as yet unclassified' stamp: 'chc 11/20/2013 16:09'!
flagthing: anObject
	flag := anObject! !

!MorphComposite methodsFor: 'as yet unclassified' stamp: 'chc 11/6/2013 15:52'!
next
	^self! !

!MorphCrossExperiment methodsFor: 'as yet unclassified' stamp: 'chc 11/20/2013 16:12'!
drawOwnerOn: aCanvas
	flagthing := false.
	self next ifNotNilDo: [:ne | ne drawOn: aCanvas]! !

!MorphCrossExperiment methodsFor: 'as yet unclassified' stamp: 'chc 11/6/2013 15:50'!
next

	^ next contents! !

!MorphCrossExperiment methodsFor: 'as yet unclassified' stamp: 'chc 11/6/2013 15:51'!
next: anObject
	| holder |
	holder := MorphStateHolder new.
	holder contents: anObject.
	next := holder
	! !

MorphCrossExperiment subclass: #MorphDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Morphic'!

MorphDecoration subclass: #CrossMorphVerticalDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Morphic'!

!CrossMorphVerticalDecoration methodsFor: 'as yet unclassified' stamp: 'chc 11/5/2013 16:46'!
drawOn: aCanvas
	| crossWidth verticalBar |
	"super drawOn: aCanvas."
	crossWidth := bounds width / 3.0.
	verticalBar := bounds insetBy: crossWidth @ 0. 
	aCanvas fillRectangle: verticalBar color: self color.
	
	self next drawOwnerOn: aCanvas! !

Object subclass: #MorphStateHolder
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Morphic'!

!MorphStateHolder methodsFor: 'accessing' stamp: 'chc 11/4/2013 16:17'!
contents

	^ contents! !

!MorphStateHolder methodsFor: 'accessing' stamp: 'chc 11/4/2013 16:17'!
contents: anObject

	contents := anObject! !
